using System;
using System.Collections;
using System.Text;
using System.Xml;

namespace Berkeley.CS160.ExperienceLogger.Contexts
{
    public abstract class ADefaultContext : IContext
    {
        private string m_type;
        private string m_name;

        public ADefaultContext(string type, string name)
        {
            m_type = type;
            m_name = name;
        }

        public string Name
        {
            get { return m_name; }
            set { m_name = value; }
        }

        public string Type
        {
            get { return m_type; }
            set { m_type = value; }
        }

        public abstract XmlNode CreateDescription(Logger logger);

        protected XmlNode CreateDefaultDescription(Logger logger)
        {
            XmlNode node = logger.CreateElement("Context");
            XmlAttribute typeAtt = logger.CreateAttribute("type");
            typeAtt.Value = m_type;
            node.Attributes.Append(typeAtt);

            if (m_name != null)
            {
                XmlAttribute nameAtt = logger.CreateAttribute("name");
                nameAtt.Value = m_name;
                node.Attributes.Append(nameAtt); 
            }

            return node;

        }
    }
}
