#region Using directives

using System;
using System.Xml;

#endregion

namespace Berkeley.CS160.ExperienceLogger.Contexts
{
    /// <summary>
    /// Summary description for CurrentTimeContext.
    /// </summary>
    public class CurrentTimeContext : ADefaultContext
    {
        public CurrentTimeContext(string name)
            : base("current_time", name)
        {

        }

        public CurrentTimeContext() : this(null) { }

        public override System.Xml.XmlNode CreateDescription(Logger logger)
        {
            XmlNode node = CreateDefaultDescription(logger);
            XmlAttribute valueAtt = logger.CreateAttribute("time");
            valueAtt.Value = DateTime.Now.ToShortDateString() + " " + DateTime.Now.ToLongTimeString();
            node.Attributes.Append(valueAtt);

            return node;
        }
    }
}
