using System;
using System.Collections;
using System.Text;
using System.Xml;

namespace Berkeley.CS160.ExperienceLogger.Contexts
{
    public class TextContext : ADefaultContext
    {
        private string m_value;

        public TextContext(string value) : base("text",null)
        {
            m_value = value;
        }

        public TextContext(string value, string name) : base("text",name)
        {
            m_value = value;
        }

        public string Value
        {
            get { return m_value; }
            set { m_value = value; }
        }

        public override XmlNode CreateDescription(Logger logger)
        {
            XmlNode node = CreateDefaultDescription(logger);

            XmlAttribute valueAtt = logger.CreateAttribute("value");
            valueAtt.Value = m_value;
            node.Attributes.Append(valueAtt);

            return node;
        }
    }
}
