using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace FlowLayout
{
	public enum LayoutStyle{ GridLayout, FlowLayout}

	public class FlowLayoutPanel : System.Windows.Forms.Panel
	{
		#region Private Members

		private System.ComponentModel.IContainer components = null;
		private LayoutStyle myLayoutStyle;
        private int m_padding = 0;

		#endregion

		#region Constructors

		public FlowLayoutPanel()
		{
            this.LayoutStyle = LayoutStyle.FlowLayout;
			InitializeComponent();
		}

		#endregion

		#region Public Properties

        public int Padding
        {
            get { return m_padding; }
            set { m_padding = value; }
        }
		
		public LayoutStyle LayoutStyle
		{
			get
			{
				return myLayoutStyle;
			}
			set
			{
				myLayoutStyle = value;
			}
		}

		#endregion


		#region Protected Methods

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}



		public void Layout()
		{
			if (this.LayoutStyle == LayoutStyle.FlowLayout)
			{
                int nextTop = 0;
                int nextLeft = 0;

				int ParentWidth;
				if (this.Parent != null)
				{
					ParentWidth = this.Parent.Width;
				}
				else
				{
					ParentWidth = this.Width;
				}
				foreach(Control myControl in this.Controls)
				{
					myControl.Top = nextTop;
					myControl.Left = nextLeft;

                    nextTop = myControl.Bottom + Padding;
				}
			}
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion

		#endregion
	}
}

