#region Using directives

using System;
using System.Runtime.InteropServices;

#endregion

namespace Berkeley.CS160.ExperienceLogger
{
    /// <summary>
    /// Summary description for PhoneUtilities.
    /// </summary>
    public class PhoneUtilities
    {
        private static uint m_ledCount;
        private static bool m_ledCounted = false;

        private PhoneUtilities()
        { }

        public static bool Vibrate(TimeSpan duration)
        {
            System.Windows.Forms.Timer timer = new System.Windows.Forms.Timer();
            timer.Interval = (int)(duration.TotalMilliseconds);
            timer.Tick += new EventHandler(VibrateTimerTick);
            timer.Enabled = true;
            return StartVibrating();
        }

        public static bool StopVibrating()
        {
            return OpenNETCF.WindowsCE.Forms.Vibrate.Stop();
        }

        public static bool StartVibrating()
        {
            return OpenNETCF.WindowsCE.Forms.Vibrate.Play();
        }

        static void VibrateTimerTick(object sender, EventArgs e)
        {
            StopVibrating();
            ((System.Windows.Forms.Timer)sender).Enabled = false;
        }
    }
}

